<?php
namespace HCM\Util\ModeloImportacao;

class BasicEntityESocial
{
	private $eventName;
	private $fields;
    private $columnNames;

	public function __construct($eventName)
	{
		$this->eventName   = $eventName;
		$this->fields      = array();
        $this->columnNames = array();
	}

	public function getEventName()
	{
		return $this->eventName;
	}

	public function getFields()
	{
		return $this->fields;
	}

    public function getFieldsAll()
    {
        $fields = $this->fields;
        foreach ($fields as $name => $value) {
            if (is_array($value)) {
                $children = array();
                /** @var BasicEntityESocial $child */
                foreach ($value as $id => $child) {
                    $children[] = $child->getFieldsAll();
                }
                $fields[$name] = $children;
            }
        }
        return $fields;
    }

	public function addField($field, $value) 
	{
		$this->fields[strtoupper($field)] = $value;
		if (!in_array($field, $this->columnNames)) {
			$this->columnNames[] = trim(strtoupper($field));
		}
	}

	public function getField($field) 
	{
		$result = null;
		if (isset($this->fields[$field])) {
			$result = $this->fields[$field];
		}

		return $result;
	}

	public function hasColumn($columnName)
	{
		$columnName = str_replace("#", "", $columnName);
		return in_array($columnName, $this->getColumnNames());
	}

	public function getColumnNames() 
	{
		return $this->columnNames;
	}
}