-- ============================================================
--   Created on:     04/10/2018  11:00                         
-- ============================================================

-- ============================================================
-- Table: GPE_MOTIVOCANCAP
-- ============================================================
CREATE TABLE GPE_MOTIVOCANCAP
(
  NRORG           NUMBER        NOT NULL,
  NRMOTIVOCANCAP  NUMBER        NOT NULL,
  NMMOTIVOCANCAP  VARCHAR2(100) NOT NULL,
  CDESOCIAL       VARCHAR2(2)   NULL,
  IDATIVO         VARCHAR2(1)		DEFAULT 'S' NOT NULL
		CONSTRAINT CKC_IDATIVO_MTVCANCAP CHECK (IDATIVO IN ('N','S')),
	DTINCLUSAO			DATE			    DEFAULT SYSDATE NOT NULL,
	DTULTATU			  DATE			    NULL,
	NRORGINCLUSAO		NUMBER(22)		DEFAULT 1 NULL,
	CDOPERINCLUSAO	VARCHAR2(12)	DEFAULT '1' NULL,
	NRORGULTATU			NUMBER(22)		DEFAULT 1 NULL,
	CDOPERULTATU		VARCHAR2(12)	DEFAULT '1' NULL,
	CONSTRAINT PK_GPE_MOTIVOCANCAP PRIMARY KEY (NRMOTIVOCANCAP)
)
/

INSERT INTO GPE_MOTIVOCANCAP (NRORG, NRMOTIVOCANCAP, NMMOTIVOCANCAP, CDESOCIAL) VALUES (0, 1, 'Reconsideração prevista no artigo 489 da CLT', '1')
/
INSERT INTO GPE_MOTIVOCANCAP (NRORG, NRMOTIVOCANCAP, NMMOTIVOCANCAP, CDESOCIAL) VALUES (0, 2, 'Determinação Judicial', '2')
/
INSERT INTO GPE_MOTIVOCANCAP (NRORG, NRMOTIVOCANCAP, NMMOTIVOCANCAP, CDESOCIAL) VALUES (0, 3, 'Cumprimento de norma legal', '3')
/
INSERT INTO GPE_MOTIVOCANCAP (NRORG, NRMOTIVOCANCAP, NMMOTIVOCANCAP, CDESOCIAL) VALUES (0, 4, 'Outros', '9')
/

-- ============================================================
-- Table: GPE_VINCULOM
-- ============================================================
ALTER TABLE GPE_VINCULOM ADD DTCANCAVIPRE DATE NULL
/
ALTER TABLE GPE_VINCULOM ADD NRMOTIVOCANCAP NUMBER NULL
/
CREATE INDEX GPE_VINCULOM_MTVCANCAP_FK ON GPE_VINCULOM (NRMOTIVOCANCAP ASC)
/
ALTER TABLE GPE_VINCULOM
  ADD CONSTRAINT FK_GPEVINC_MTVCANCAP FOREIGN KEY (NRMOTIVOCANCAP)
    REFERENCES GPE_MOTIVOCANCAP (NRMOTIVOCANCAP)
/
ALTER TABLE GPE_VINCULOM ADD DSOBSCANCAVIPRE VARCHAR2(500)
/