CREATE OR REPLACE PROCEDURE PRODUCAO_PREVSVCOC(
P_LISTAPREVCOC IN VARCHAR2,
P_CIAS IN VARCHAR2,
P_CLASSES IN VARCHAR2,
P_CICLOS IN VARCHAR2,
P_DATACUSTO IN DATE,
P_TIPOCUSTO IN NUMBER,
P_NRPRODUCAOCOC IN OUT FLOAT
)
AS
V_NRPRODUCAOCOC VARCHAR2(20);
V_NRRECPRODUCOC VARCHAR2(20);
V_NRSUBRECPRODUCOC VARCHAR2(20);
V_NRPRODPRODUCOC VARCHAR2(20);
V_QTBRUTA FLOAT;
V_VRYIELD FLOAT;
V_QTESTOQUE FLOAT;
V_VRCUSTOUNIT FLOAT;
V_VRCUSTOTOTAL FLOAT;
BEGIN
   IF P_NRPRODUCAOCOC IS NULL THEN
      NOVO_CODIGO_SC('PRODUCAOCOC',V_NRPRODUCAOCOC);
      P_NRPRODUCAOCOC := TO_NUMBER(V_NRPRODUCAOCOC);
   ELSE
      DELETE FROM PRODPRODUCOC WHERE NRPRODUCAOCOC = P_NRPRODUCAOCOC;
      DELETE FROM SUBRECPRODUCOC WHERE NRPRODUCAOCOC = P_NRPRODUCAOCOC;
      DELETE FROM RECPRODUCOC WHERE NRPRODUCAOCOC = P_NRPRODUCAOCOC;      
   END IF;
   /* Produtos amarrados diretamente em subgrupos(sem receita atrelada). Insere um a um*/
   FOR C_PRODSUBGRU IN
   (
      SELECT PV.CDFILIAL, P.CDPRODUTO, P.CDSETOR, 
             ROUND(SUM(P.QTPRODPREVSVCOC), 3) AS QUANTIDADE,
             MAX(NVL(PO.VRPEFATOCORR, 0)) AS VRPEFATOCORR
        FROM LISTA L             
             INNER JOIN PREVSVCOC PV ON PV.NRPREVSVCOC = TO_NUMBER(L.CDLISTA)
             INNER JOIN PRODPREVSVCOC P ON PV.NRPREVSVCOC = P.NRPREVSVCOC
             INNER JOIN PRODUTO PO ON PO.CDPRODUTO = P.CDPRODUTO
             INNER JOIN SERVPREVSVCOC S ON S.NRSERVPREVSVCOC = P.NRSERVPREVSVCOC        
       WHERE L.NRLISTA = P_LISTAPREVCOC
         AND (P_CIAS = 'T' OR INSTR(P_CIAS, S.CDCIA) <> 0)
         AND (P_CLASSES = 'T' OR INSTR(P_CLASSES, S.CDCLASSE) <> 0)
         AND (P_CICLOS = 'T' OR INSTR(P_CICLOS, S.CDCICLO) <> 0)
         AND NRRECPREVSVCOC IS NULL
       GROUP BY P.CDPRODUTO, P.CDSETOR, PV.CDFILIAL
   ) LOOP
      NOVO_CODIGO_SC('PRODPRODUCOC', V_NRPRODPRODUCOC);
      
      --Estoque do dia
      SELECT NVL(MAX(QTESTOQDIA), 0.0)
        INTO V_QTESTOQUE
        FROM POSESTDIA
       WHERE CDFILIAL = C_PRODSUBGRU.CDFILIAL
         AND CDPRODUTO = C_PRODSUBGRU.CDPRODUTO
         AND DTPOSIESTQ = (                   

         SELECT NVL(MAX(P.DTPOSIESTQ), NULL)
           FROM POSESTDIA P
          WHERE (P.CDFILIAL = C_PRODSUBGRU.CDFILIAL) AND
                (P.CDPRODUTO = C_PRODSUBGRU.CDPRODUTO) AND
                (P.DTPOSIESTQ <= SYSDATE)
        
         );
      V_VRYIELD := ROUND(100 - C_PRODSUBGRU.VRPEFATOCORR, 2);
      V_QTBRUTA := ROUND(C_PRODSUBGRU.QUANTIDADE / (1 - C_PRODSUBGRU.VRPEFATOCORR/100), 3);  
      
      V_VRCUSTOUNIT := CUSTO_PRODUTO_COC(C_PRODSUBGRU.CDFILIAL, C_PRODSUBGRU.CDPRODUTO, P_DATACUSTO, P_TIPOCUSTO);
      V_VRCUSTOTOTAL := ROUND(V_VRCUSTOUNIT * V_QTBRUTA, 2);
      
      INSERT INTO PRODPRODUCOC
      (NRPRODUCAOCOC, NRPRODPRODUCOC,
       CDPRODUTO, CDSETOR,
       NRRECPRODUCOC, QTPRODPRODUCOC,
       QTBRUTA, VRYIELD,
       QTESTOQUE, VRCUSTOUNIT, VRCUSTOTOTAL, DTULTATU)
      VALUES
      (P_NRPRODUCAOCOC, TO_NUMBER(V_NRPRODPRODUCOC),
       C_PRODSUBGRU.CDPRODUTO, C_PRODSUBGRU.CDSETOR,
       NULL, C_PRODSUBGRU.QUANTIDADE,
       V_QTBRUTA, V_VRYIELD,
       V_QTESTOQUE, V_VRCUSTOUNIT, V_VRCUSTOTOTAL, SYSDATE);
   END LOOP;
   
   /* Receitas agregadas. Percorre uma a uma inserindo a composio*/
   FOR C_RECEITAS IN
   (
   SELECT PV.CDFILIAL, R.CDRECEITA, R.CDSETOR, ROUND(SUM(R.QTRECPREVSVCOC), 3) AS QUANTIDADE
     FROM LISTA L
          INNER JOIN PREVSVCOC PV ON PV.NRPREVSVCOC = TO_NUMBER(L.CDLISTA)
          INNER JOIN RECPREVSVCOC R ON R.NRPREVSVCOC = PV.NRPREVSVCOC
          INNER JOIN SERVPREVSVCOC S ON S.NRSERVPREVSVCOC = R.NRSERVPREVSVCOC
    WHERE L.NRLISTA = P_LISTAPREVCOC
      AND (P_CIAS = 'T' OR INSTR(P_CIAS, S.CDCIA) <> 0)
      AND (P_CLASSES = 'T' OR INSTR(P_CLASSES, S.CDCLASSE) <> 0)
      AND (P_CICLOS = 'T' OR INSTR(P_CICLOS, S.CDCICLO) <> 0)  
    GROUP BY R.CDRECEITA, R.CDSETOR, PV.CDFILIAL
   ) LOOP
      NOVO_CODIGO_SC('RECPRODUCOC', V_NRRECPRODUCOC);
      
      V_VRCUSTOUNIT := CUSTO_RECEITA_COC(C_RECEITAS.CDFILIAL, C_RECEITAS.CDRECEITA, P_DATACUSTO, P_TIPOCUSTO);
      V_VRCUSTOTOTAL := C_RECEITAS.QUANTIDADE * V_VRCUSTOUNIT;
      
      INSERT INTO RECPRODUCOC
      (NRPRODUCAOCOC, NRRECPRODUCOC, CDRECEITA,
       CDSETOR, QTRECPRODUCOC,
       VRCUSTOUNIT, VRCUSTOTOTAL, DTULTATU)      
      VALUES
      (P_NRPRODUCAOCOC, TO_NUMBER(V_NRRECPRODUCOC), C_RECEITAS.CDRECEITA,
       C_RECEITAS.CDSETOR, C_RECEITAS.QUANTIDADE,
       V_VRCUSTOUNIT, V_VRCUSTOTOTAL, SYSDATE);
      
      /* Subreceitas da receita agregadas. Insere uma a uma na receita*/
      FOR C_SUBREC IN
      (
      SELECT PV.CDFILIAL, R.CDRECEITA, R.CDSETOR, ROUND(SUM(R.QTRECPREVSVCOC), 3) AS QUANTIDADE
        FROM LISTA L
             INNER JOIN PREVSVCOC PV ON PV.NRPREVSVCOC = TO_NUMBER(L.CDLISTA)
             INNER JOIN RECPREVSVCOC R ON R.NRPREVSVCOC = PV.NRPREVSVCOC             
             INNER JOIN SERVPREVSVCOC S ON S.NRSERVPREVSVCOC = R.NRSERVPREVSVCOC
       WHERE L.NRLISTA = P_LISTAPREVCOC
         AND (P_CIAS = 'T' OR INSTR(P_CIAS, S.CDCIA) <> 0)
         AND (P_CLASSES = 'T' OR INSTR(P_CLASSES, S.CDCLASSE) <> 0)
         AND (P_CICLOS = 'T' OR INSTR(P_CICLOS, S.CDCICLO) <> 0)
         AND R.CDRECEITAPAI = C_RECEITAS.CDRECEITA
       GROUP BY R.CDRECEITA, R.CDSETOR, PV.CDFILIAL
      ) LOOP
         NOVO_CODIGO_SC('SUBRECPRODUCOC', V_NRSUBRECPRODUCOC);
         
         V_VRCUSTOUNIT := CUSTO_RECEITA_COC(C_SUBREC.CDFILIAL, C_SUBREC.CDRECEITA, P_DATACUSTO, P_TIPOCUSTO);
         V_VRCUSTOTOTAL := C_SUBREC.QUANTIDADE * V_VRCUSTOUNIT;
         
         INSERT INTO SUBRECPRODUCOC
         (NRPRODUCAOCOC, NRSUBRECPRODUCOC,
          NRRECPRODUCOC, CDRECEITA,
          CDSETOR, QTSRECPRODUCOC,
          VRCUSTOUNIT, VRCUSTOTOTAL, DTULTATU)
         VALUES
         (P_NRPRODUCAOCOC, TO_NUMBER(V_NRSUBRECPRODUCOC),
          TO_NUMBER(V_NRRECPRODUCOC), C_SUBREC.CDRECEITA,
          C_SUBREC.CDSETOR, C_SUBREC.QUANTIDADE,
          V_VRCUSTOUNIT, V_VRCUSTOTOTAL, SYSDATE);
      
      END LOOP;
      
      /* Insumos da receita agregados. Insere um a um na receita*/
      FOR C_PRODREC IN
      (
      SELECT PV.CDFILIAL, P.CDPRODUTO, P.CDSETOR,
        ROUND(SUM(P.QTPRODPREVSVCOC), 3) AS QUANTIDADE,
             MAX(NVL(PO.VRPEFATOCORR, 0)) AS VRPEFATOCORR
        FROM LISTA L             
             INNER JOIN PREVSVCOC PV ON PV.NRPREVSVCOC = TO_NUMBER(L.CDLISTA)
             INNER JOIN PRODPREVSVCOC P ON PV.NRPREVSVCOC = P.NRPREVSVCOC
             INNER JOIN PRODUTO PO ON PO.CDPRODUTO = P.CDPRODUTO
             INNER JOIN SERVPREVSVCOC S ON S.NRSERVPREVSVCOC = P.NRSERVPREVSVCOC
             INNER JOIN RECPREVSVCOC R ON R.NRRECPREVSVCOC = P.NRRECPREVSVCOC AND
                                          R.CDRECEITA = C_RECEITAS.CDRECEITA
       WHERE L.NRLISTA = P_LISTAPREVCOC
         AND (P_CIAS = 'T' OR INSTR(P_CIAS, S.CDCIA) <> 0)
         AND (P_CLASSES = 'T' OR INSTR(P_CLASSES, S.CDCLASSE) <> 0)
         AND (P_CICLOS = 'T' OR INSTR(P_CICLOS, S.CDCICLO) <> 0)
       GROUP BY P.CDPRODUTO, P.CDSETOR, PV.CDFILIAL
      ) LOOP
         NOVO_CODIGO_SC('PRODPRODUCOC', V_NRPRODPRODUCOC);
         
         --Estoque do dia
         SELECT NVL(MAX(QTESTOQDIA), 0.0)
           INTO V_QTESTOQUE
           FROM POSESTDIA
          WHERE CDFILIAL = C_PRODREC.CDFILIAL
            AND CDPRODUTO = C_PRODREC.CDPRODUTO
            AND DTPOSIESTQ = (                   

            SELECT NVL(MAX(P.DTPOSIESTQ), NULL)
              FROM POSESTDIA P
             WHERE (P.CDFILIAL = C_PRODREC.CDFILIAL) AND
                   (P.CDPRODUTO = C_PRODREC.CDPRODUTO) AND
                   (P.DTPOSIESTQ <= SYSDATE)
           
            );
         
         V_VRYIELD := ROUND(100 - C_PRODREC.VRPEFATOCORR, 2);
         V_QTBRUTA := ROUND(C_PRODREC.QUANTIDADE / (1 - C_PRODREC.VRPEFATOCORR/100), 3);  
         
         V_VRCUSTOUNIT := CUSTO_PRODUTO_COC(C_PRODREC.CDFILIAL, C_PRODREC.CDPRODUTO, P_DATACUSTO, P_TIPOCUSTO);
         V_VRCUSTOTOTAL := ROUND(V_VRCUSTOUNIT * V_QTBRUTA, 2);
         
         INSERT INTO PRODPRODUCOC
         (NRPRODUCAOCOC, NRPRODPRODUCOC,
          CDPRODUTO, CDSETOR,
          NRRECPRODUCOC, QTPRODPRODUCOC,
          QTBRUTA, VRYIELD,
          QTESTOQUE, VRCUSTOUNIT, VRCUSTOTOTAL, DTULTATU)
         VALUES
         (P_NRPRODUCAOCOC, TO_NUMBER(V_NRPRODPRODUCOC),
          C_PRODREC.CDPRODUTO, C_PRODREC.CDSETOR,
          TO_NUMBER(V_NRRECPRODUCOC), C_PRODREC.QUANTIDADE,
          V_QTBRUTA, V_VRYIELD,
          V_QTESTOQUE, V_VRCUSTOUNIT, V_VRCUSTOTOTAL, SYSDATE);
         
      END LOOP;
      
   END LOOP;   
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PRODUCAO_PREVSVCOC','5.85.xxx'); END;
/